#include "ants.h"								// TAB2ŌĂ

Earth* Ant::m_earth = NULL;
random_walk Ant::m_random_walk;
#ifdef _ANTS_GUI_
HWND   Earth::m_hWnd = NULL;
#endif

nextpos::nextpos()
{
	m_val         = 512-1;
	int           i;
	for( i=0; i< 9; i++) {		// Ô߂ɏݒ肵Ă
		m_pval[i]   = 0;
	}
	for( i=0; i< 512; i++) {
		m_vals[i]   = NULL;
	}
}

nextpos::~nextpos()
{
	clear();
}

void nextpos::clear()
{
	for( int i=0; i< 512; i++) {
		delete[] m_vals[i];
		m_vals[i]   = NULL;
	}
}

void nextpos::initialize( int pval[9])
{
	clear();
	for( int i=0; i< 9; i++) {
		m_pval[i]   = pval[i];
	}
}

void nextpos::reset()
{
	m_val         = 512-1;
}

/**
 * ̈ʒuo
 */
int nextpos::get_next()
{
	int bits[]={1,2,4,8,16,32,64,128,256};
	if( m_vals[m_val] == NULL) {
		alloc(m_val);
	}
	int           n = m_vals[m_val][0]; // ԍŏɌĂ
	if( n==0) return 0;						// vɕԂlĂƁB0̕px̏ꍇB
	//ps( _T("get_next(), n:%d\n"), n);
	mt_assert(n>=0);
	int           idx = m_vals[m_val][(rand()%n)+1];
	mt_assert(idx>=0&&idx<9);
	m_val         = m_val & ~bits[idx];
	mt_assert(m_val>=0&&m_val<512);
	return    idx;
}

/**
 * ̈mۂďopx
 */
void nextpos::alloc( int val)
{
	//ps( _T("alloc(%d)\n"), val);
	mt_assert(val>=0&&val<512);
	int           n = 0;					// opx̍v
	int           i, bit=1;
	for( i=0; i< 9; i++) {
		if( m_val&bit) {							// cĂPnΏۂƂB
			n         += m_pval[i] ;	// opx̍v߂B
		}
		bit         <<=1;
	}
	m_vals[val]   = new int[n+1];	// 擪n邽+1
	m_vals[val][0]= n;
	int           m = 1;					// 擪nĂ̂[1]Pnnݒ肵ĂB
	bit           = 1;
	for( i=0; i< 9; i++) {
		if( m_val&bit) {
			for( int j=0; j< m_pval[i]; j++) {
				m_vals[val][m++] = i;
				mt_assert(m<=n+1);
			}
		}
		bit         <<= 1;
	}
}

/**
 * 
 */
int random_walk::get_next( int row, int col, int row_prev, int col_prev, int& row_new, int& col_new)
{
	int           diff_row = row-row_prev;
	int           diff_col = col-col_prev;
	if(!(abs(diff_row)<=1&&abs(diff_col)<=1)) { // ́}1͈̔͂ɂȂ΂ȂȂ
		ps( _T("row:%d, col:%d, row_prev:%d, col_prev:%d\n"), row, col, row_prev, col_prev);
	}
	mt_assert(abs(diff_row)<=1&&abs(diff_col)<=1); // ́}1͈̔͂ɂȂ΂ȂȂ
	mt_assert(!(diff_row==0&&diff_col==0));	// (row,col)(row_prev,col_prev)ʒuł͂Ȃ
	int           type_para_diag = abs(diff_row)+abs(diff_col);	// 1 or 2
	int           idx = (diff_row+1)*3 + (diff_col+1);
	int           type[] = {7,3,6,4,0,2,8,1,5};
	int           trans_diff_row[][9]={
		{0,0,0,0,0,0,0,0,0},				// dummy
		{0,1,1,0,-1,-1,-1,0,1},
		{0,0,-1,-1,-1,0,1,1,1},
		{0,-1,-1,0,1,1,1,0,-1},
		{0,0,1,1,1,0,-1,-1,-1},
		{0,1,1,0,-1,-1,-1,0,1},
		{0,0,-1,-1,-1,0,1,1,1},
		{0,-1,-1,0,1,1,1,0,-1},
		{0,0,1,1,1,0,-1,-1,-1},
	};
	int           trans_diff_col[][9]={
		{0,0,0,0,0,0,0,0,0},				// dummy
		{0,0,1,1,1,0,-1,-1,-1},
		{0,1,1,0,-1,-1,-1,0,1},
		{0,0,-1,-1,-1,0,1,1,1},
		{0,-1,-1,0,1,1,1,0,-1},
		{0,0,1,1,1,0,-1,-1,-1},
		{0,1,1,0,-1,-1,-1,0,1},
		{0,0,-1,-1,-1,0,1,1,1},
		{0,-1,-1,0,1,1,1,0,-1},
	};
	int           pos;
	//ps(_T("Type:%d, idx:%d, diff_row:%d, diff_col:%d\n"),type[idx], idx, diff_row, diff_col);
	if( type_para_diag == 1) {
		//ps( _T("TypePara\n"));
		pos         = m_para.get_next();
		//pos         = trans[type[idx]][pos];
		row_new     = row + trans_diff_row[type[idx]][pos];
		col_new     = col + trans_diff_col[type[idx]][pos];
	}
	else if( type_para_diag == 2) {
		//ps( _T("TypeDiag\n"));
		pos         = m_diag.get_next();
		//pos         = trans[type[idx]][pos];
		row_new     = row + trans_diff_row[type[idx]][pos];
		col_new     = col + trans_diff_col[type[idx]][pos];
	}
	else {
		//mt_assert(0);
	}
	return 0;
}

Ant::Ant()
{
	reset();
	m_num_movable = 0;						// oƂɐݒ肷
}

Ant::~Ant()
{
}

void Ant::do_action()
{
	switch( m_mode) {
	case SearchFood:							// GTT
		if( is_in_nest()) {					// ̒ɂꍇ
			move_out();								// Oɏo
		}
		else if( is_over_walk()) {	// ?
			change_mode(MoveHome);
		}
		else {
			move_random();						// _ɕ,AړłȂƂ
		}
		if( is_exist_food()) {			// ɃGT邩ׂ
			change_mode(BiteFood);		// GT𚗂ĎA
		}
		break;
	case GetFood:									// GTɏo
		if( is_in_nest()) {					// ̒ɂꍇ
			move_out();								// ܂͊Oɏo
		}
		else if( move_to_food()) {	// GTɌĈړ
			if( is_exist_food()) {		// ɃGT邩
				change_mode(BiteFood);	// GT𚗂
			}
#if 1														// ? {͂Ȃłǂ͂Ȃ͓̂Ȃƍs藈JԂďIȂȂB
			else if( is_over_walk()) {	// ?
				plog( _T("over walkID:%d at pos(%d,%d) walk:%d %d\n"), m_id, m_pos_cur.m_row, m_pos_cur.m_col, m_num_walk, m_num_movable);
				change_mode(MoveHome);
			}
#endif
		}
		else {											// GT̓HȂȂ
			// 1.GT̋߂ŕʂ̋a邽߃GTɋ߂ÂȂB
			// 2.GTȂēHȂȂB
			// 3.GTĂaCrł炪̏ɂĈړłȂB
			//   ɃGTAāCočsƂɑB
			// GT̋߂ŃGT̓HȂȂꍇƁCꡂŒHȂȂꍇB
			// ꡂ̏ꍇ͍GœOB
			// GT̋߂̏ꍇ̓GTHׂĂ܂ꍇB
			plog( _T("GTȂID:%d foods:%d current(%d,%d) prev(%d,%d)\n"), m_id, m_num_foods, m_pos_cur.m_row, m_pos_cur.m_col, m_pos_prev.m_row, m_pos_prev.m_col);
			if( m_earth->is_near_foods( m_pos_cur)) {	// Ă̈ʒuɃGT
				m_num_movable = SUBDISTANCE; // ߂ɃGTƎv̂ŒZ߂ɒT
				change_mode(SearchFood);
			}
			else {										// GT̋߂ł͂Ȃ̂œT,
				m_num_movable = SUBDISTANCE; // 
				change_mode(SearchSmell);
			}
			m_pos_smell_center    = m_pos_cur;// ̃R[h SearchSmellӖCSearchFoodɕςӖȂǁCSearchSmellɖ߂mȂ̂ł̂܂܎cĂ
		}
		break;
	case MoveHome:								// ɋA,GTĂ邢ȂɍS炸ɋA낤Ƃ
		if( move_to_home()) {				// ɌĈړ,YES̏ꍇ͑ɋA蒅ꍇB
			change_mode(IDLE);
			reset();
		}
		else if( m_num_foods <= 0 && is_exist_food()) { //GTɋArGTꍇBHɑ݂B
			change_mode(BiteFood);		// GT𚗂
		}
		break;
	case BiteFood:								// GT𚗂,ۂ̋aƈꔭŐĂł͂Ȃ
		if( bite_foods()) {					// GT𚗂
			m_earth->smell( m_pos_cur);	// ̈ʒuƃGT̈ʒuɃGT̓c
			change_mode(MoveHome);		// GTđɋA
		}
		else if( !is_exist_food()) {// ɕʂ̋aɎăGTȂȂĂꍇ
			change_mode(m_mode_prev);	// O{GTT|GTɍs}ɖ߂B
		}
		break;
	case SearchSmell:							// T,Tn߂̒SSMELLDISTANCE͈͓̔ŒT
		if( move_to_smell()) {
			change_mode(GetFood);			// Ăѓ̂ŃGTɖ߂
			m_num_movable = DISTANCE;	// ̒lɊւĂ͂lȂ΂ȂȂB[BUG]
		}
		else if( is_over_walk()) {	// T?
			change_mode(MoveHome);
		}
		break;
	case IDLE:										// ̒ɂ
		break;											// ɂ邱Ƃ͂Ȃ
	default:
		mt_assert(0);								// vOG[
	}
}

#include <math.h>
int getdist( int row, int col, int row_center, int col_center)
{
	return    sqrt((row-row_center)*(row-row_center)+(col-col_center)*(col-col_center));
}

/**
 * ߏɓTB_Ɉړ邯ǈ̋OȂ悤ɂB
 */
YesNo Ant::move_to_smell()
{
	m_random_walk.reset();
	int           row_new, col_new;
	int           cnt = 0;
	YesNo         success;
	do {
		m_random_walk.get_next( m_pos_cur.m_row, m_pos_cur.m_col, m_pos_prev.m_row, m_pos_prev.m_col, row_new, col_new);
		if( getdist(row_new,col_new,m_pos_smell_center.m_row,m_pos_smell_center.m_col) < SMELLDISTANCE) {
			AntPosition pos_new( row_new, col_new);
			success     = move_to( pos_new);
			if(success) return    m_earth->is_exist_smell(pos_new) || is_exist_food();	// TĂ邯ǐɃGTĂ܂ƂB
		}
	}while( cnt++< 8 && success == NO);
	return    NO;
}

/**
 * _Ɉړ
 */
void Ant::move_random()
{
	m_random_walk.reset();
	int           row_new, col_new;
	int           cnt = 0;
	YesNo         success;
	do {
		m_random_walk.get_next( m_pos_cur.m_row, m_pos_cur.m_col, m_pos_prev.m_row, m_pos_prev.m_col, row_new, col_new);
		AntPosition pos_new( row_new, col_new);
		success     = move_to( pos_new);
	}while( cnt++< 8 && success == NO);	// ͂8ӏړł܂ŌJԂ
}

/**
 * GT̓HăGTɍsB
 * r؂ꂽ߂ċABArGT̓ĂB
 * GTɍs߂̍s񂪁usivłȂȂ邽߂ɁC炩̍HvKvB
 * ߂肵ȂŊmɃGTɌĂ@lKvB
 */
YesNo Ant::move_to_food()
{
	AntPosition   pos[9];
	int           n = m_earth->get_smell_and_long_walk( m_pos_cur, pos); // GTɒH蒅߂ɂ̓GT̓痣Ă͂ȂȂB
	//return    move_to( pos, n);
	// ̃R[hƉԉ΂̂悤ɎUĂ܂B
	// move_to()move_to_force()ɕύXCԉ΂̂悤ɎU邱Ƃ͂ȂȂC
	// GTTɏo܂܂ƉʏɎcĂ܂ao悤ɂȂB
	// 2ӏs藈肷݂ȊȁB
	// ǗĂ܂ƂȂB
	return    move_to_force( pos, n);
	// ȉ̃R[hɂƃGT̕t߂ɑSĂ̋aW܂ăGTȂĂIȂB
	// GTA炸AaȂȂĂ܂Bۂ̋a̋ɋ߂̂͏̃R[ĥ悤ȋCB
	//move_to_force( pos, n);return n>0;
}

/**
 * ̋ꏊTB
 * GTɗp̂ŁC݈ʒuȂΈӖȂB
 * Č݈ʒu艓ʒuŃGT̓ʒu𓾂B
 * PɓTƉʒuŃfbhbNNĂ܂B
 */
int Earth::get_smell_and_long_walk( const AntPosition& pos, AntPosition* pos_smell)
{
	int           n = 0;
	int           row = pos.m_row, col = pos.m_col;
	int           smell = m_mat[row][col].m_num_walk_from_foods; // ʒu̓̋
	if( is_exist_pos(row-1,col-1) && m_mat[row-1][col-1].m_num_walk_from_foods<smell) { pos_smell[n++]=AntPosition(row-1,col-1);}
	if( is_exist_pos(row-1,col+0) && m_mat[row-1][col+0].m_num_walk_from_foods<smell) { pos_smell[n++]=AntPosition(row-1,col+0);}
	if( is_exist_pos(row-1,col+1) && m_mat[row-1][col+1].m_num_walk_from_foods<smell) { pos_smell[n++]=AntPosition(row-1,col+1);}
	if( is_exist_pos(row+0,col-1) && m_mat[row+0][col-1].m_num_walk_from_foods<smell) { pos_smell[n++]=AntPosition(row+0,col-1);}
//if( is_exist_pos(row+0,col+0) && m_mat[row+0][col+0].m_num_walk_from_foods<smell) { pos_smell[n++]=AntPosition(row+0,col+0);}w肵ʒû̂Ȃ̂őΏۊO
	if( is_exist_pos(row+0,col+1) && m_mat[row+0][col+1].m_num_walk_from_foods<smell) { pos_smell[n++]=AntPosition(row+0,col+1);}
	if( is_exist_pos(row+1,col-1) && m_mat[row+1][col-1].m_num_walk_from_foods<smell) { pos_smell[n++]=AntPosition(row+1,col-1);}
	if( is_exist_pos(row+1,col+0) && m_mat[row+1][col+0].m_num_walk_from_foods<smell) { pos_smell[n++]=AntPosition(row+1,col+0);}
	if( is_exist_pos(row+1,col+1) && m_mat[row+1][col+1].m_num_walk_from_foods<smell) { pos_smell[n++]=AntPosition(row+1,col+1);}
	//	if( smell <= 1 && n > 1) {		// OɃGT̂ʒuŃEEȂ߂Ƀ_ɓւB
	if( n > 1) {
		int         rnd1, rnd2;
		int         m = n/2;
		for( int i=0; i< m; i++) {	// 񐔂͔ɂ
			rnd1      = rand() % n;
			rnd2      = rand() % n;
			swap( pos_smell[rnd1], pos_smell[rnd2]);
		}
		// łǂقǂ̌ʂ邩
	}
	return    n;
}

/**
 * GTĂ/ȂɍS炸ɋAB
 * ƂɋA邽߂ɑՂHB
 * ɒƂ YES ԂB
 * ȊO NO ԂB
 * ړǂ͔ȂB
 */
YesNo Ant::move_to_home()
{
	// ̑Ղ݂̂̑Ղ̏ՂTB
	// aŔ΂悤ȂƂȂ̂ŏՂ͎ɕKƂB
	// ÄʒuɊɕʂ̋a邱ƂB
	AntPosition   pos[9];
	int           n = m_earth->get_short_walk( m_pos_cur, pos);
	if( move_to_force( pos, n)) {				//  move_to_force() ɕύXƃV[gJbg₷
		if( m_earth->is_nest( m_pos_cur)) {	// ɒ
			m_earth->arrived_home( *this); // ɒƂ񍐂
			return    YES;
		}
	}
	else {
		// ̋aēȂB
	}
	return    NO;									// ܂ɒĂȂ
}

/**
 * ̎ɂGT𚗂B
 * GTɎɗ悤ɃGT̈ʒuɓcĂB
 * GTȊÖʒu͑ɋArɎcB
 */
YesNo Ant::bite_foods()
{
	int           success = rand()%1000;
	if( success < BITESUCCESS) {	// 100̂BITESUCCESSɃGT𚗂邱Ƃɐ,炵Ă]ω悤ȋC
		AntPosition pos[9];
		int         num_foods_pos = m_earth->is_exist_food( m_pos_cur, pos); // ̎̃GT𒲂ׂ,ő8ӏ̉\
		if( num_foods_pos == 0) {		// GTȂȂĂ܂,GTڂ̑Oɑ̋aɂ݂ȎĂ܂B
			return    NO;
		}
		int         ipos = rand() % num_foods_pos; // GT̂ num_foods_pos ̂ӏ߂ẴGT𚗂
		AntPosition bitepos = pos[ipos];
		int         num_foods = m_earth->bite_foods(pos[ipos],1/**/,m_pos_cur);// ̂Ƃ뚗ʂ1,GTAʂ͏ꍇɂĈႤ͂
		if( num_foods > 0) {
			m_num_foods   = num_foods; // GT
			m_num_walk_from_foods = m_earth->get_num_smell(pos[ipos])+1; // GT̈ʒu1ƂB
			return    YES;
		}
		mt_assert(0);								// vOG[
		return    NO;								// ̂Ƃ낱͂蓾Ȃ
	}
	return    NO;
}

/**
 * ݈ʒu̎ɃGT邩?
 * GT𓥂݂ԂĂꍇ͖ƌȂB
 */
YesNo Ant::is_exist_food()
{
	AntPosition   pos[9];
	return    m_earth->is_exist_food( m_pos_cur, pos)>0;
}

/**
 * ̊OɏoB
 * GTTꍇƃGTɍsꍇŏقȂB
 * GTTɍsꍇ͎芸OɏoΗǂB
 * GTɍsꍇ̂ꏊɏoȂ΂ȂȂB
 */
void Ant::move_out()
{
	// OɏôŊOɏoƂ̏lݒ肷B
	m_num_foods   = 0;
	m_num_walk    = 0;
	m_num_movable = DISTANCE;
	m_num_walk_from_foods = 0;
	if( m_mode == SearchFood) {		// GTTɍs
		ps( _T("move_out():SearchFoodID:%d\n"), m_id);
		// GTTɏoƂ͊OɏoΗǂƂB
		// ȂƂ͈x݁B
		AntPosition pos[9];
		int n = m_earth->get_exit_pos( pos); // o擾
		if( n > 0 && move_to( pos[rand()%n])) {  // ̂̈ɈړNotYet悭l炱ꂾƕs\B
			// NotYetSĎĂȂȁ[
		}
	}
	else if( m_mode == GetFood) {	// GTɍs
		ps( _T("move_out():GetFoodID:%d\n"), m_id);
		// GTɍsƂ͓HꏊɏoȂ΂ȂȂB
		AntPosition pos[9];
		int         n = m_earth->get_smell_and_long_walk( m_pos_cur, pos); // GT̓Hꏊ擾
		move_to( pos, n);						// ̏ꏊɈړ
	}
	else {
		mt_assert(0);								// vOG[
	}
}

/**
 * ȏȂقǕ?
 */
YesNo Ant::is_over_walk()
{
	if( m_num_movable <= 0) {
		return    YES;
	}
	return    NO;
}

/**
 * ȁԂωB
 */
void Ant::change_mode( AntMode mode_new)
{
	ps( _T("change_modeID:%d mode:%d -> %d\n"), m_id, m_mode, mode_new);
	m_earth->count_down_mode( m_mode);
	m_mode_prev   = m_mode;
	m_mode        = mode_new;
	m_earth->count_up_mode( mode_new);
}

/**
 * ̒ɂ?
 * ړ0̏ꍇ̒ɂƌȂBɂ@肻͂̕@̗pB
 */
YesNo Ant::is_in_nest()
{
	return    m_num_walk==0;
}

/**
 * w肵ʒu̎ɃGT͂邩?
 * w肵ʒû̂͑ΏۊOƂB
 */
int Earth::is_exist_food( const AntPosition& pos, AntPosition* pos_food)
{
	int           n = 0;
	int           row = pos.m_row, col = pos.m_col;
	if( is_exist_pos(row-1,col-1) && m_mat[row-1][col-1].m_num_foods>0) { pos_food[n++]=AntPosition(row-1,col-1);}
	if( is_exist_pos(row-1,col+0) && m_mat[row-1][col+0].m_num_foods>0) { pos_food[n++]=AntPosition(row-1,col+0);}
	if( is_exist_pos(row-1,col+1) && m_mat[row-1][col+1].m_num_foods>0) { pos_food[n++]=AntPosition(row-1,col+1);}
	if( is_exist_pos(row+0,col-1) && m_mat[row+0][col-1].m_num_foods>0) { pos_food[n++]=AntPosition(row+0,col-1);}
//if( is_exist_pos(row+0,col+0) && m_mat[row+0][col+0].m_num_foods>0) { pos_food[n++]=AntPosition(row+0,col+0);}w肵ʒû̂Ȃ̂őΏۊO
	if( is_exist_pos(row+0,col+1) && m_mat[row+0][col+1].m_num_foods>0) { pos_food[n++]=AntPosition(row+0,col+1);}
	if( is_exist_pos(row+1,col-1) && m_mat[row+1][col-1].m_num_foods>0) { pos_food[n++]=AntPosition(row+1,col-1);}
	if( is_exist_pos(row+1,col+0) && m_mat[row+1][col+0].m_num_foods>0) { pos_food[n++]=AntPosition(row+1,col+0);}
	if( is_exist_pos(row+1,col+1) && m_mat[row+1][col+1].m_num_foods>0) { pos_food[n++]=AntPosition(row+1,col+1);}
	return    n;
}

/**
 * GT𚗂,GT炷
 */
int Earth::bite_foods( const AntPosition& foodpos, int num_foods, const AntPosition& antpos)
{
	int           row = foodpos.m_row, col = foodpos.m_col;
	mt_assert( is_exist_pos(row,col));
	num_foods     = max(min( m_mat[row][col].m_num_foods, num_foods),0);	// ۂɚ
	m_mat[row][col].m_num_foods   -= num_foods;
	if( m_mat[row][col].m_num_foods == 0) m_mat[row][col].m_num_foods = -1;	// ̍
	if( num_foods> 0) {						// GT蚗邱Ƃo
		if( m_mat[row][col].m_num_walk_from_foods == INT_MAX) {	// ̐ݒ肪܂
			m_mat[antpos.m_row][antpos.m_col].m_num_walk_from_foods = m_smell_value+1;
			m_mat[row][col].m_num_walk_from_foods = m_smell_value--; // GT̂ʒuL^
		}
		return    num_foods;
		if( m_mat[row][col].m_num_walk_from_foods != INT_MAX) {
			if( m_mat[antpos.m_row][antpos.m_col].m_num_walk_from_foods <= 2) {	// ȑÖʒuŃGT邱Ƃo
				// ̏ꍇ݂͌̈ʒu2ȉɂȂĂ͂Ȃ̂Ō݈ʒȕ͂̂܂܂ɂĂB
				m_mat[row][col].m_num_walk_from_foods = m_mat[antpos.m_row][antpos.m_col].m_num_walk_from_foods - 1;
			}
			else {											// GT̂ʒuL^
				m_mat[row][col].m_num_walk_from_foods = 1; // GT̂ʒuL^
				m_mat[antpos.m_row][antpos.m_col].m_num_walk_from_foods = 2; // GT𚗂ʒu2ɂȂ
			}
		}
	}
	return    num_foods;					// GT̗
}

/**
 * ̋âȂo擾B
 * o̎8ӏ𒲂ׂċaȂΏoԂB
 */
int Earth::get_exit_pos( AntPosition* pos)
{
	int           n = 0;
	int           row = m_pos_nest.m_row, col = m_pos_nest.m_col;
	if( is_exist_pos(row-1,col-1) && m_mat[row-1][col-1].m_num_ants==0) { pos[n++]=AntPosition(row-1,col-1);}
	if( is_exist_pos(row-1,col+0) && m_mat[row-1][col+0].m_num_ants==0) { pos[n++]=AntPosition(row-1,col+0);}
	if( is_exist_pos(row-1,col+1) && m_mat[row-1][col+1].m_num_ants==0) { pos[n++]=AntPosition(row-1,col+1);}
	if( is_exist_pos(row+0,col-1) && m_mat[row+0][col-1].m_num_ants==0) { pos[n++]=AntPosition(row+0,col-1);}
//if( is_exist_pos(row+0,col+0) && m_mat[row+0][col+0].m_num_ants==0) { pos[n++]=AntPosition(row+0,col+0);}̂̂Ȃ̂őΏۊO
	if( is_exist_pos(row+0,col+1) && m_mat[row+0][col+1].m_num_ants==0) { pos[n++]=AntPosition(row+0,col+1);}
	if( is_exist_pos(row+1,col-1) && m_mat[row+1][col-1].m_num_ants==0) { pos[n++]=AntPosition(row+1,col-1);}
	if( is_exist_pos(row+1,col+0) && m_mat[row+1][col+0].m_num_ants==0) { pos[n++]=AntPosition(row+1,col+0);}
	if( is_exist_pos(row+1,col+1) && m_mat[row+1][col+1].m_num_ants==0) { pos[n++]=AntPosition(row+1,col+1);}
	return    n;
}

/**
 * wʒuɋ߂ʒuTB
 * {̓\[gĕԂǂ...NotYet
 */
int Earth::get_short_walk( const AntPosition& pos, AntPosition* pos_short)
{
	int           n = 0;
	int           row = pos.m_row, col = pos.m_col;
	int           curwalk = m_mat[row][col].m_walk_steps;
	if( is_exist_pos(row-1,col-1) && m_mat[row-1][col-1].m_walk_steps<curwalk) { pos_short[n++]=AntPosition(row-1,col-1);}
	if( is_exist_pos(row-1,col+0) && m_mat[row-1][col+0].m_walk_steps<curwalk) { pos_short[n++]=AntPosition(row-1,col+0);}
	if( is_exist_pos(row-1,col+1) && m_mat[row-1][col+1].m_walk_steps<curwalk) { pos_short[n++]=AntPosition(row-1,col+1);}
	if( is_exist_pos(row+0,col-1) && m_mat[row+0][col-1].m_walk_steps<curwalk) { pos_short[n++]=AntPosition(row+0,col-1);}
//if( is_exist_pos(row+0,col+0) && m_mat[row+0][col+0].m_walk_steps<curwalk) { pos_short[n++]=AntPosition(row+0,col+0);}݈ʒu͑ΏۊO
	if( is_exist_pos(row+0,col+1) && m_mat[row+0][col+1].m_walk_steps<curwalk) { pos_short[n++]=AntPosition(row+0,col+1);}
	if( is_exist_pos(row+1,col-1) && m_mat[row+1][col-1].m_walk_steps<curwalk) { pos_short[n++]=AntPosition(row+1,col-1);}
	if( is_exist_pos(row+1,col+0) && m_mat[row+1][col+0].m_walk_steps<curwalk) { pos_short[n++]=AntPosition(row+1,col+0);}
	if( is_exist_pos(row+1,col+1) && m_mat[row+1][col+1].m_walk_steps<curwalk) { pos_short[n++]=AntPosition(row+1,col+1);}
	mt_assert(n>0);								// ɋ߂ʒu݂͌̎dlł͕K͂
#if 1
	if( n > 1) {
		int         rnd1, rnd2;
		int         m = n/2;
		for( int i=0; i< m; i++) {	// 񐔂͔ɂ
			rnd1      = rand() % n;
			rnd2      = rand() % n;
			swap( pos_short[rnd1], pos_short[rnd2]);
		}
		// łǂقǂ̌ʂ邩
	}
#endif
	return    n;
}

/**
 * aẅʒuɈړB
 * aړƂ̏ꏊł̋a̐B
 * ƓL^B
 */
void Earth::move_to( Ant& ant, const AntPosition& pos)
{
	AntPosition   pos_cur = ant.m_pos_cur;
	if( ant.m_num_walk > 1) {
		count_down_ants( pos_cur);
	}
	count_up_ants( pos, ant.m_mode, ant.m_num_foods); // ړ̋a̐͑
	int           row = pos.m_row;
	int           col = pos.m_col;
	int           walk = ant.m_num_walk;
	mt_assert(is_exist_pos(row,col));
	if( walk < m_mat[row][col].m_walk_steps) { // sȑOZ
		m_mat[row][col].m_walk_steps    = walk;	// Zso^
	}
	if( ant.m_num_foods> 0) {			// GTĂc
		m_mat[row][col].m_num_smell++; // c
		if( ant.m_num_walk_from_foods < m_mat[row][col].m_num_walk_from_foods) { // (l)
			m_mat[row][col].m_num_walk_from_foods   = ant.m_num_walk_from_foods; // 苭c
		}
	}
}

/**
 * mode̋a
 */
void Earth::count_up_mode( AntMode mode)
{
	switch( mode) {
	case SearchFood:							// GTT
		m_num_worker++;
		break;
	case GetFood:									// GTɏo
		m_num_worker++;
		break;
	case MoveHome:								// ɋA,GTĂ邢ȂɍS炸ɋA낤Ƃ
		m_num_worker++;
		break;
	case BiteFood:								// GT𚗂,ۂ̋aƈꔭŐĂł͂Ȃ
		m_num_worker++;
		break;
	case SearchSmell:
		m_num_worker++;
		break;
	case IDLE:										// ̒ɂ
		break;											// ɂ邱Ƃ͂Ȃ
	default:
		mt_assert(0);								// vOG[
	}
	m_num_max_worker  = max( m_num_max_worker, m_num_worker);
}

/**
 * mode̋a
 */
void Earth::count_down_mode( AntMode mode)
{
	switch( mode) {
	case SearchFood:							// GTT
		m_num_worker--;
		break;
	case GetFood:									// GTɏo
		m_num_worker--;
		break;
	case MoveHome:								// ɋA,GTĂ邢ȂɍS炸ɋA낤Ƃ
		m_num_worker--;
		break;
	case BiteFood:								// GT𚗂,ۂ̋aƈꔭŐĂł͂Ȃ
		m_num_worker--;
		break;
	case SearchSmell:
		m_num_worker--;
		break;
	case IDLE:										// ̒ɂ
		break;											// ɂ邱Ƃ͂Ȃ
	default:
		mt_assert(0);								// vOG[
	}
}

/**
 * num_foodsGUIpɒǉB
 */
void Earth::count_up_ants( const AntPosition& pos, AntMode mode, int num_foods)
{
	int           row = pos.m_row, col = pos.m_col;
	mt_assert(is_exist_pos(row,col));
	m_mat[row][col].m_num_ants++;
#ifdef _ANTS_GUI_
	::SendMessage( m_hWnd, WM_USER_MSG1, num_foods*256+mode, row*COLS+col);	// ̈ʒuɋa\,modeŋa̐Fςĕ\ł悤ɂ
#endif
}

void Earth::count_down_ants( const AntPosition& pos)
{
	int           row = pos.m_row, col = pos.m_col;
	mt_assert(is_exist_pos(row,col)&&m_mat[row][col].m_num_ants>0);
	m_mat[row][col].m_num_ants--;
#ifdef _ANTS_GUI_
	::SendMessage( m_hWnd, WM_USER_MSG2, (m_mat[row][col].m_num_foods<<16)|m_mat[row][col].m_num_smell, row*COLS+col);	// ̈ʒűa
#endif
}

Earth::Earth()
{
	Ant::m_earth = this;
	clear();
	// P8 P1 P2
	// P7 P0 P3
	// P6 P5 P4
	int para[]={0,400,20,5,2,0,2,5,20};// a_ɕm,{ɂŗǂ͌ۑ
	int diag[]={0,20,400,20,5,2,0,2,5};
	Ant::initialize(para,diag);
#ifdef _ANTS_GUI_
	m_event.create();
#endif
}

Earth::~Earth()
{
}

/**
 * 
 */
void Earth::clear()
{
	for( int row=0; row< ROWS; row++) {
		for( int col=0; col< COLS; col++) {
			m_mat[row][col].m_walk_steps  = INT_MAX;
			m_mat[row][col].m_num_foods   = 0;
			m_mat[row][col].m_num_ants    = 0;
			m_mat[row][col].m_num_smell   = 0;
			m_mat[row][col].m_num_walk_from_foods = INT_MAX;
		}
	}
	m_num_foods   = 0;
	m_num_foods_prev  = 0;
	m_num_worker  = 0;
	m_smell_value = 1;
	m_num_max_worker  = 0;
}

#ifdef _ANTS_GUI_
int debug_food_row=400, debug_food_col=400;	// ԂŃGTuʒu
#else
//int debug_food_row=18, debug_food_col=7;
//int debug_food_row=226, debug_food_col=254;
int debug_food_row=400, debug_food_col=400;
#endif

/**
 * 
 */
void Earth::do_action()
{
	m_num_foods_prev  = m_num_foods; // ݂̃GT̗ʂL^,dlł̓GT邱Ƃ͍lȂ
	for( int i=0; i< NUMANTS; i++) { // SĂ̋a̓XV
		m_ants[i].do_action();
	}
	int           num_add = m_num_foods - m_num_foods_prev;
	mt_assert(num_add>=0);				// dlł̓GT邱Ƃ͍lĂȂ
	if( num_add > 0) {						// GTꍇCGTɍsB
		ps( _T("GT̂ŋa%dCǉ,c̃GT%d\n"), num_add, m_mat[debug_food_row][debug_food_col].m_num_foods);
		//		change_ants_mode( num_add, IDLE, SearchFood);	// GTċAĂa̕VɃGTTɏo
		change_ants_mode( num_add * NUMBITE, IDLE, GetFood); // GT̗ʂGTɏo
	}
}

int Earth::change_ants_mode( int num_ants, AntMode mode_prev, AntMode mode_new)
{
	ps( _T("change_ants_mode(num_ants:%d mode%d->%d)\n"), num_ants, mode_prev, mode_new);
	int           cnt = 0;
	for( int i=0; i< NUMANTS && num_ants > 0; i++) {
		if( m_ants[i].m_mode == mode_prev) {
			m_ants[i].change_mode( mode_new);
			num_ants--;
			cnt++;
		}
	}
	return    cnt;
}

/**
 * aGTTɏoB
 */
void Earth::initialize()
{
	{															// for DEBUG
		m_pos_nest    = AntPosition(NEST_X,NEST_Y);	// ̈ʒu
#if 1														// for DEBUG
		{														// GTzu,x̑傫̋`̈ɓKȗʂu
			for(int row=debug_food_row-3;row<=debug_food_row+10;row++) {
				for(int col=debug_food_col-3;col<=debug_food_col+20;col++) {
					m_mat[row][col].m_num_foods=3; // GTu
#ifdef _ANTS_GUI_
					::SendMessage( m_hWnd, WM_USER_MSG2, (m_mat[row][col].m_num_foods<<16)|m_mat[row][col].m_num_smell, row*COLS+col); // GT\
#endif // _ANTS_GUI_
				}
			}
		}
#endif // GT̔zu
	}
	mt_assert( NUMWORKER<NUMANTS);
	for( int i=0; i< NUMANTS; i++) { // SĂ̋a͑ɂ
		m_ants[i].reset();
		// ȉ̐ݒȂƉȂ?
		m_ants[i].m_pos_cur     = m_pos_nest;
		m_ants[i].m_pos_prev    = m_pos_nest;	// Ô
		m_ants[i].m_id          = i;
	}
	m_mat[m_pos_nest.m_row][m_pos_nest.m_col].m_walk_steps = 0;
	m_mat[m_pos_nest.m_row][m_pos_nest.m_col].m_num_walk_from_foods   = INT_MAX;
	m_num_worker  = 0;
	change_ants_mode( NUMWORKER, IDLE, SearchFood);	// NUMWORKER̐̋ȁԂGTTɕύXB
}

/**
 * aGTTɏoĂSAĂ܂łV~[gB
 */
void Earth::this_program()
{
	initialize();									// aGTTɏo
	int           loop=0;
	do {
		do_action();								// a̍sXV
#ifdef _ANTS_GUI_
		wait();											// ʏ̑ňꎞ~o悤ɂ
#endif		
		if( (++loop%100) == 0) {		// ܂ɃOɏ
			plog( _T("num_worker:%d num_foods:%d %dloop\n"), m_num_worker, m_num_foods, loop);
		}
	}while( m_num_worker > 0);		// SĂ̋aɖ߂I
	{															// for DEBUG, cĂGT͂?
		int         num_foods = 0;
		for( int row=0; row< ROWS; row++) {
			for( int col=0; col< COLS; col++) {
				num_foods   += max(m_mat[row][col].m_num_foods,0);
				mt_assert(m_mat[row][col].m_num_ants==0);	// a͑SđɋAĂ͂
			}
		}
		plog( _T("̒ɃGT %d Cc̃GT͒n %d ܂Cnɏoa̍ő吔 %d łB\n"), m_num_foods, num_foods, m_num_max_worker);
#ifdef _ANTS_GUI_
		{
			mt_vchars msg;
			msg.copy_format( _T("̒ɃGT %d Cc̃GT͒n %d ܂Cnɏoa̍ő吔 %d łB\n"), m_num_foods, num_foods, m_num_max_worker);
			AfxMessageBox( msg);
		}
#endif
	}
}

/**
 * ݈ʒuʒuɈړB
 * SĂ̌ʒuɈړłȂƂ́CNOԂB
 */
YesNo Ant::move_to( const AntPosition* pos, int n)
{
	int           i;
	for( i=0; i< n && move_to(pos[i]) == NO; i++) {
		// NOP
	}
	if( i>= n) {									// ǑSĂɈړłȂ
		ps( _T("%d ӏړłȂID:%d to(%d,%d)\n"), n, m_id, pos[0].m_row, pos[0].m_col);
		return    NO;
	}
	return    YES;
}

/**
 * ݈ʒuʒuɈړB
 * SĂ̌ʒuɈړłȂƂ́Cʒű߂ɈړB
 */
YesNo Ant::move_to_force( const AntPosition* pos, int n)
{
	int           i;
	for( i=0; i< n && move_to(pos[i]) == NO; i++) {
		// NOP
	}
	if( i>= n) {									// ǑSĂɈړłȂ
		ps( _T("%dӏړłȂID:%d to(%d,%d)\n"), n, m_id, pos[0].m_row, pos[0].m_col);
		// wʒű߂ɈړłΈړB
		for( i=0; i< n && move_to_neighbor(pos[i]) == NO; i++) {
			// NOP
		}
		if( i>= n) {
			// ǂǂɂړłȂBx݁B
			ps( _T("ǂǂɂړłȂ̂ňx\n"));
			return    NO;
		}
	}
	return    YES;
}

/**
 * wʒuɈړB
 */
YesNo Ant::move_to( const AntPosition& pos)
{
	if( m_earth->is_empty( pos)) { // ʂ̋aȂ̂ňړłB
		m_num_walk++;								// 
		if(m_num_foods>0)m_num_walk_from_foods++;
		m_num_movable--;						// ̂ňړ\͌
		m_earth->move_to( *this, pos); // ړɂ镛pvZ
		m_pos_prev  = m_pos_cur;		// ݈ʒuXV
		m_pos_cur   = pos;
		return    YES;
	}
	return    NO;
}

/**
 * wʒű߂ɈړB
 * poŝɈړłȂƂ͔ĂB
 * pos͉P̈ʒuBC݂͌̈ʒuBړł̂öʒuB
 * oPo __o  ___  o__ _oP ___ ___ Po_
 * _C_ _CP  _C_  PC_ _Co _Co oC_ oC_
 * ___ __o  oPo  o__ ___ _oP Po_ ___
 */
YesNo Ant::move_to_neighbor( const AntPosition& pos)
{
	AntPosition   pos_neighbor[2];
	get_rand_neighbor( m_pos_cur, pos, pos_neighbor);
	return    move_to(pos_neighbor[0]) || move_to(pos_neighbor[1]);
}

/**
 * ̈ʒuɋa͂?
 */
YesNo Earth::is_empty( const AntPosition& pos) const
{
	int           row = pos.m_row, col = pos.m_col;
	
	return    is_exist_pos(row,col)&&m_mat[row][col].m_num_ants == 0;
}

/**
 * pos̋ߏ߂B
 */
void Ant::get_rand_neighbor( const AntPosition& pos_cur, const AntPosition& pos, AntPosition pos_neighbor[2])
{
	int           diff_row = pos.m_row - pos_cur.m_row;
	int           diff_col = pos.m_col - pos_cur.m_col;
	int           idx = (diff_row+1)*3 + (diff_col+1);
	int           x=0;// dummy,̒`𔻂₷邽
	int           rows0[] = {-1,-1, 0,-1,x, 1, 0, 1, 1};
	int           cols0[] = { 0, 1, 1,-1,x, 1,-1,-1, 0};
	int           rows1[] = { 0,-1,-1, 1,x,-1, 1, 1, 0};
	int           cols1[] = {-1,-1, 0,-1,x, 1, 0, 1, 1};
	int           rand0=rand()%2, rand1=(rand0+1)&1;
	pos_neighbor[rand0] = AntPosition( pos_cur.m_row+rows0[idx], pos_cur.m_col+cols0[idx]);
	pos_neighbor[rand1] = AntPosition( pos_cur.m_row+rows1[idx], pos_cur.m_col+cols1[idx]);
}

/**
 * x~ԂɂȂϐB
 */
void Ant::reset()
{
	m_mode        = IDLE;
	m_mode_prev   = IDLE;
	m_num_foods   = 0;
	m_num_walk    = 0;
	m_num_movable = 0;						// oƂɐݒ肷
	m_num_walk_from_foods = 0; 		// GT,GTƂ1ɐݒ肷
}

void Earth::dump( int row, int col, int sz)
{
	if( !is_exist_pos(row,col)) {
		plog( _T("Earth::dump(row:%d,col:%d,sz:%d) out of matrix\n"), row, col, sz);
		return;
	}
	mt_vchars     out;
	out.copy_format( _T("\n"));
	out.copy_format( _T("   :"));
	for( int icol=-sz; icol<= sz; icol++) {
		out.copy_format( _T("%3d          "), col+icol);
	}
	out.copy_format( _T("\n"));
	for( int irow=-sz; irow<= sz; irow++) {
		out.copy_format( _T("%3d:"), row+irow);
		for( int icol=-sz; icol<= sz; icol++) {
			if( is_exist_pos(row+irow,col+icol)) {
				struct_mat& mat = m_mat[row+irow][col+icol];
				//out.copy_format( _T("[%d][%d]"), row+irow, col+icol);
				out.copy_format( _T("%2d/%3d/%2d/%2d "), mat.m_num_ants, mat.m_walk_steps==INT_MAX?0:mat.m_walk_steps%1000, mat.m_num_foods, mat.m_num_walk_from_foods==INT_MAX?0:mat.m_num_walk_from_foods%1000);
			}
		}
		out.copy_format( _T("\n"));
	}
	plog( _T("%s"), (cstring)out);
}

void Earth::dump( const Ant& ant)
{
	AntPosition   pos = ant.m_pos_cur;
	mt_assert(is_exist_pos(pos.m_row,pos.m_col));
	int           row = pos.m_row, col = pos.m_col;
	dump( row, col, 5/*sz*/);
}

/**
 * GT̓c
 */
void Earth::smell( const AntPosition& pos)
{
	int     row = pos.m_row, col = pos.m_col;
	mt_assert(is_exist_pos(row,col));
	m_mat[row][col].m_num_smell++;
	ps( _T("Earth::smell(%d,%d):%d\n"), row, col, m_mat[row][col].m_num_smell);
}

/**
 * w肵ʒu?
 */
YesNo Earth::is_nest( const AntPosition& pos)
{
	if( pos.m_row == m_pos_nest.m_row && pos.m_col == m_pos_nest.m_col) {
		return    YES;
	}
	return    NO;
	return    pos == m_pos_nest;
}

/**
 * aɋAB
 */
void Earth::arrived_home( Ant& ant)
{
	int           row = m_pos_nest.m_row, col = m_pos_nest.m_col;
	m_mat[row][col].m_num_ants--;	// ̈ʒu͏ʉ߂邱Ƃ͏o邯ǁCɋA炻̈ʒűa͂Ȃ̂Ƃ
	m_num_foods   += ant.m_num_foods;	// GTĂ/ȂɍS炸JEgB
	ant.m_num_foods   = 0; // ɂ둃ɒ玝ĂGT̗ʂ0ɂȂ
	// ȉ͂Ȃėǂ?
	ant.m_num_walk    = 0;
	ant.m_num_movable = 0;
#ifdef _ANTS_GUI_
	::SendMessage( m_hWnd, WM_USER_MSG2, 0, row*COLS+col); // aɓ̂ŋa̕\
	::SendMessage( m_hWnd, WM_USER_MSG3, m_num_worker-1, m_num_foods); // -1Ă̂͋Aa̐܂-1ĂȂ̂
#endif
}

/**
 * ̈ʒuɓ͂?
 */
YesNo Earth::is_exist_smell( const AntPosition& pos)
{
	int           row = pos.m_row, col = pos.m_col;
	mt_assert(is_exist_pos(row,col));
	return    m_mat[row][col].m_num_smell;
}

/**
 * ̍
 */
int Earth::get_num_smell( const AntPosition& pos) const
{
	int           row = pos.m_row, col = pos.m_col;
	mt_assert(is_exist_pos(row,col));
	return    m_mat[row][col].m_num_walk_from_foods;
}

/**
 * GT̂߂?
 */
YesNo Earth::is_near_foods( const AntPosition& pos) const
{
	int           row = pos.m_row, col = pos.m_col;
	mt_assert(is_exist_pos(row,col));
	return    m_mat[row][col].m_num_foods != 0; // 
	return    m_mat[row][col].m_num_walk_from_foods <= 1;
}
